/*
 * V1.0 - Programm fertiggestellt.
 * 
 * V1.1 - Ausgabe auf Kommandozeile hinzugefgt.
 * 		  An/Ausschaltbares Trayicon hinzugefgt
 *
 * V1.1.1 - Bug gefixt (Trayicon funktionierte nicht
 * 						und tauchte mehrfach auf)
 *
 * Funktioniert mit W700V, W500V, W502V
 *
 *
 * TODO:	IP aus Args auslesen, wenn nicht vorhanden, Standard nehmen!
 * 			701 Lauffhig machen!
 */

package net.cyb0rk.sw700vr;

import java.awt.AWTException;
import java.awt.Image;
import java.awt.SystemTray;
import java.awt.Toolkit;
import java.awt.TrayIcon;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.URL;
import java.net.URLConnection;


public class Main
{
	public static void main(String[] args) throws IOException, AWTException, InterruptedException
	{
		/*
		 * Variablen erzeugen.
		 */
		
		boolean cTrayIcon = true;
		
		/*
		 * Prfen ob "notray" beim Programmstart angegeben wurde.
		 */
		
		if (args.length > 0 && args[0].equals("notray"))
		{
			// Festlegen dass kein Trayicon erzeugen werden soll.
			cTrayIcon = false;
		}
		
		/*
		 * ffnet eine Verbindung zu der URL und wartet bis sie
		 * fertig geladen ist.
		 */
		
		// Das Verbinungsziel festlegen.
		URL router = new URL("http://192.168.2.1/cgi-bin/disconnect.exe");
		// Die Verbinung ffnen
		URLConnection rc = router.openConnection();
		// Die Daten lesbar machen.
		BufferedReader in = new BufferedReader(new InputStreamReader(rc.getInputStream()));

		/*
		 * Liest die Daten der Verbindung aus.
		 */
		
		while (in.readLine() != null)
		{
		}
		in.close();
		
		/*
		 * Wenn Das System einen Systray hat und notray nicht
		 * angegeben wurde das Trayicon erzeugen. Ansonsten
		 * eine Textnachricht auf die Standardausgabe schreiben.
		 */
		
		if (SystemTray.isSupported() && cTrayIcon == true)
		{
			// Das Bild fr das Trayicon laden.
			URL imageURL = Main.class.getResource("/tray.png");
			Image image = Toolkit.getDefaultToolkit().getImage(imageURL);
			// Das Trayicon mit dem Namen SW700VR erzeugen.
			TrayIcon trayIcon = new TrayIcon(image, "SW700VR");
			// Systemtray des Betriebssystemes ansprechen.
			SystemTray tray = SystemTray.getSystemTray();
			
			// Das Trayicon dem Systemtrayhinzufgen
			tray.add(trayIcon);
			// Eine Nachricht vom Typ INFO ber das Trayicon erzeugen.
			trayIcon.displayMessage("Das Speedport W700V Reconnect Programm wurde ausgefhrt.", 
					"In wenigen Sekunden erhalten wird ihnen eine neue IP-Adresse zugewiesen.", 
					TrayIcon.MessageType.INFO);
		} else {
			// Text auf die Standardausgabe schreiben.
			System.out.println("Das Speedport W700V Reconnect Programm wurde ausgefhrt.\n" +
					"In wenigen Sekunden erhalten wird ihnen eine neue IP-Adresse zugewiesen.");
		}
		
		// 5 Sekunden warten.
		Thread.sleep(5000);
		
		System.exit(0);
	}
}